import 'package:buzz_widgets/src/utils/buzz_size_utils.dart';
import 'package:flutter/material.dart';

class BuzzResponsiveLayout extends StatelessWidget {
  final Widget? xs;
  final Widget sm;
  final Widget? md;
  final Widget? lg;
  final Widget? xl;

  const BuzzResponsiveLayout({
    Key? key,
    this.xs,
    required this.sm,
    this.md,
    this.lg,
    this.xl,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return LayoutBuilder(builder: (context, dimensions) {
      return BuzzSizeUtils.resize<Widget>(
          maxWidth: dimensions.maxWidth,
          size: ScreenSizes<Widget>(
            xs: xs,
            sm: sm,
            md: md,
            lg: lg,
            xl: xl,
          ));
    });
  }
}
